---
title: HTML guidelines
slug: MDN/Guidelines/Code_guidelines/HTML
tags:
  - Code
  - Guide
  - Guidelines
  - HTML
  - MDN Meta
---
<div>{{MDNSidebar}}</div>

<p class="summary">The following guidelines cover how to write HTML for MDN code examples.</p>

<h2 id="In_this_article">In this article</h2>

<ul>
	<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Doctype_and_metadata">Doctype and metadata</a>

	<ul>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Doctype">Doctype</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Document_language">Document language</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Document_characterset">Document characterset</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Viewport_meta_tag">Viewport meta tag</a></li>
	</ul>
	</li>
	<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#General_markup_coding_style">General markup coding style</a>
	<ul>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Use_lowercase">Use lower case</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Trailing_slashes">Trailing slashes</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Quoting_attributes">Quoting attributes</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Use_double_quotes">Use double quotes</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Boolean_attributes">Boolean attributes</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Class_and_ID_names">Class and ID names</a></li>
		<li><a href="/en-US/docs/MDN/Contribute/Guidelines/Code_guidelines/HTML#Entity_references">Entity references</a></li>
	</ul>
	</li>
</ul>

<h2 id="Doctype_and_metadata">Doctype and metadata</h2>

<div class="note">
<p><strong>Note</strong>: The guidelines in this section apply only when you need to show a complete HTML document. Most of the time you won't need to do this; a snippet is usually enough to demonstrate a feature. When using the <a href="/en-US/docs/MDN/Contribute/Structures/Code_examples#Traditional_live_samples">EmbedLiveSample macro</a>, just include the HTML snippet; it will automatically be inserted it into a full HTML document when displayed.</p>
</div>

<h3 id="Doctype">Doctype</h3>

<p>You should use the HTML5 doctype. It is short, easy to remember, and backwards compatible:</p>

<pre class="brush: html example-good notranslate">&lt;!DOCTYPE html&gt;</pre>

<h3 id="Document_language">Document language</h3>

<p>Set the document language using the {{htmlattrxref('lang')}} attribute on your {{htmlelement("html")}} element:</p>

<pre class="brush: html example-good notranslate">&lt;html lang="en-US"&gt;</pre>

<p>This is good for accessibility and search engines, helps with localizing content, and reminds people to use best practices.</p>

<h3 id="Document_characterset">Document characterset</h3>

<p>You should also define your document's characterset like so:</p>

<pre class="brush: html example-good notranslate">&lt;meta charset="utf-8"&gt;</pre>

<p>Use UTF-8 unless you have a very good reason not to; it will cover your character needs pretty much regardless of what language you are using in your document. In addition, you should always specify the characterset as early as possible within your HTML's {{HTMLElement("head")}} block (within the first kilobyte), as it protects against a rather <a href="http://support.microsoft.com/kb/928847">nasty Internet Explorer security vulnerability</a>.</p>

<h3 id="Viewport_meta_tag">Viewport meta tag</h3>

<p>Finally, you should always add the viewport meta tag into your HTML {{HTMLElement("head")}}, to give the example a better chance of working on mobile devices. You should include at least the following in your document, which can be modified later on as the need arises:</p>

<pre class="brush: html example-good notranslate">&lt;meta name="viewport" content="width=device-width"&gt;</pre>

<p>See <a href="/en-US/docs/Mozilla/Mobile/Viewport_meta_tag">Using the viewport meta tag to control layout on mobile browsers</a> for further details.</p>

<h2 id="General_markup_coding_style">General markup coding style</h2>

<h3 id="Use_lowercase">Use lowercase</h3>

<p>Use lowercase for all element names and attribute names/values, as it looks neater and means you can write markup faster:</p>

<p>This is good:</p>

<pre class="brush: html example-good notranslate">&lt;p class="nice"&gt;This looks nice and neat&lt;/p&gt;</pre>

<p>This is not so good:</p>

<pre class="brush: html example-bad notranslate">&lt;P CLASS="WHOA-THERE"&gt;Why is my markup shouting?&lt;/P&gt;</pre>

<h3 id="Trailing_slashes">Trailing slashes</h3>

<p>Don't include XHTML-style trailing slashes for empty elements, as they are unnecessary and slow things down. They can also break old browsers if you are not careful (although from what we can recall, this hasn't been a problem since Netscape 4).</p>

<p>This is fine:</p>

<pre class="brush: html example-good notranslate">&lt;input type="text"&gt;
&lt;hr&gt;</pre>

<p>The slashes are not needed:</p>

<pre class="brush: html example-bad notranslate">&lt;input type="text" /&gt;
&lt;hr /&gt;</pre>

<h3 id="Quoting_attributes">Quoting attributes</h3>

<p>You should put all attribute values in double quotes. It is tempting to omit quotes since HTML5 allows this, but markup is neater and easier to read if you do include them. For example, this is better:</p>

<pre class="brush: html example-good notranslate">&lt;img src="images/logo.jpg" alt="A circular globe icon" class="no-border"&gt;</pre>

<p>than this:</p>

<pre class="brush: html example-bad notranslate">&lt;img src=images/logo.jpg alt=A circular globe icon class=no-border&gt;</pre>

<p>It can also cause problems — in the above example the <code>alt</code> attribute will be interpreted as multiple attributes, because there are no quotes to specify that "A circular globe icon" is a single attribute value.</p>

<h3 id="Use_double_quotes">Use double quotes</h3>

<p>Use double quotes for HTML, not single quotes:</p>

<pre class="brush: html example-good notranslate">&lt;p class="important"&gt;Yes&lt;/p&gt;</pre>

<pre class="brush: html example-bad notranslate">&lt;p class='important'&gt;Nope&lt;/p&gt;</pre>

<h3 id="Boolean_attributes">Boolean attributes</h3>

<p>Don't write out boolean attributes in full; you can just write the attribute name to set it. For example, you can write:</p>

<pre class="brush: html example-good notranslate">required</pre>

<p>This is perfectly understandable and works fine. Instead of writing out the longer version with the value</p>

<pre class="brush: html example-bad notranslate">required="required" </pre>

<p>Which is supported but not necessary.</p>

<h3 id="Class_and_ID_names">Class and ID names</h3>

<p>Use semantic class/ID names, and separate multiple words with hyphens. Don't use camelCase.</p>

<p>Good:</p>

<pre class="brush: html example-good notranslate">&lt;p class="editorial-summary"&gt;Blah blah blah&lt;/p&gt;</pre>

<p>Bad:</p>

<pre class="brush: html example-bad notranslate">&lt;p class="bigRedBox"&gt;Blah blah blah&lt;/p&gt;</pre>

<h3 id="Entity_references">Entity references</h3>

<p>Don’t use entity references unnecessarily — use the literal character wherever possible (you'll still need to escape characters like angle brackets and quote marks).</p>

<p>As an example you could just write</p>

<pre class="brush: html example-good notranslate">&lt;p&gt;© 2018 Me&lt;/p&gt;</pre>

<p>Instead of</p>

<pre class="brush: html example-bad notranslate">&lt;p&gt;&amp;copy; 2018 Me&lt;/p&gt;</pre>

<p>This is fine as long as you declare a UTF-8 character set.</p>

<h2 id="Good_HTML_examples_on_MDN">Good HTML examples on MDN</h2>

<p>You can find good, concise, meaningful HTML snippets at the top of the <a href="/en-US/docs/Web/HTML/Reference">HTML reference pages</a> — our interactive examples are generally written to follow these guidelines, although be aware that they may differ in some places as they were mostly written before the guidelines were newly written.</p>
